hdu 状态压缩dp小集(中低难度)

源自---------------------------------------------------- Ice_Crazy

hdu1074
    状态压缩dp入门题,关键是输出顺序。

#include"stdio.h"
#include"string.h"
#include"stdlib.h"

int n,base[20];
struct node
{
    char name[111];
    int dead,cost;
}MEM[20];
struct node1
{
    int days,score;
    int pre,now;
}DP[1<<15];

int main()
{
    int T;
    int i,l;
    int tot,t,reduce;
    for(i=0;i<15;i++)    base[i]=1<=0;l--)        //从大到小,并且在后面的第七行用了“<”:保证顺序
            {
                if(i & base[l])
                {
                    t=i-base[l];
                    reduce=DP[t].days+MEM[l].cost-MEM[l].dead;
                    if(reduce<0)    reduce=0;
                    if(DP[t].score+reduce=0;i--)    printf("%s\n",ans[i]);
    }
    return 0;
}




hdu3182
    状态压缩dp水题。




hdu4568
    最短路+状态压缩dp、不难,两部分都较果。




hdu4336
    概率dp+状态压缩 求期望。
    没啥难的、主要是关于期望的运算。。期望。。高中的数学知识
啊、我推了半张演草纸才想起来啊。。。

#include"iostream"  
#include"cstdio"  
#include"cstring"  
using namespace std;  
const int N=1<<20;  
  
int n,base[20];  
double p[20],dp[N];  
int main()  
{  
    int i,l;  
    int limit;  
    double t,sum;  
    for(i=0;i<20;i++)    base[i]=1<




hdu1565
    很果的二进制dp。
    不过这题的数据小,所以可以这样暴力,好的方法是网络流,
可以做下hdu1569。




hdu2167
    果果的状态压缩dp。
    可以先做一下hdu1565,那个比这个更果。。
    这个题的话可以先算一下,15位的格子只有1597个可用来
递推的状态,所以,尽情的暴力吧~!= =II。




hdu4539
    很水的状态压缩dp,数据也不强,4层for循环写的pl的可以迅速过之,当然不pl也能过= =。




hdu3001
    三进制dp,思路同二进制。

#include"iostream"
#include"cstdio"
#include"cstring"
using namespace std;
const int N=60000;
const int M=1000;
const int inf=123456789;

int n,m,map[20][20],dp[N][10],sp[N][10],base[10];
struct Edge{
    int v,len,next;
}edge[M];
int tot,head[10];
void add(int a,int b,int c){
    edge[tot].v=b;edge[tot].len=c;edge[tot].next=head[a];head[a]=tot++;
}

void init()
{
    int i,k,temp,limit;
    base[0]=1;
    for(i=1;i<10;i++)    base[i]=base[i-1]*3;
    limit=base[9]*3;
    memset(sp,0,sizeof(sp));
    for(i=0;ic?c:map[a][b];
    }
    tot=0;
    memset(head,-1,sizeof(head));
    for(i=1;i<=n;i++)
    for(l=1;l<=n;l++)
    {
        if(i==l || map[i][l]==inf)    continue;
        add(i-1,l-1,map[i][l]);
    }
}
int DP()
{
    int i,l,j,v;
    int t,next,flag,limit,ans;
    limit=1;
    for(i=0;i=2)    continue;
                next=i+base[v];
                if(dp[i][l]+edge[j].len

你可能感兴趣的:(递推,DP)